v7.3.0

Tutorial - Angular

Follow the steps in this tutorial to get this app up and running:

1. Create an Angular app

In this first step we are going to create a basic Angular app using this guide from angular.io.

  1. (Optional) If you have not yet installed Angular CLI, you need to do it now using the following command:
npm install -g @angular/cli
  1. Run the following in a terminal:
ng new --skip-tests --view-encapsulation None --style scss --no-routing angular-tutorial
cd angular-tutorial
npm start

You should now have an "empty" Angular app up and running, time to include the Scheduler.

2. Include the Scheduler

Now we are going to add a minimal Scheduler to the app.

  1. Install the Scheduler packages (if you have not already, first set up the repo as per the quick start guide):
npm install @bryntum/scheduler @bryntum/scheduler-angular
If you are using a trial, replace @bryntum/scheduler with @bryntum/scheduler@npm:@bryntum/scheduler-trial.
  1. Import BryntumSchedulerModule in app.module.ts:
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';

import { AppComponent } from './app.component';
import { BryntumSchedulerModule } from '@bryntum/scheduler-angular';

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule,
    BryntumSchedulerModule
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }

Replace content of app.component.scss with:

@import "@bryntum/scheduler/scheduler.css";
@import "@bryntum/scheduler/material3-light.css";

body {
    font-family: sans-serif;
    font-size: 14px;
}

and the content of app.component.html with:

<bryntum-scheduler
  [width]="800"
  [height]="600"
  startDate="2023-04-16"
  endDate="2023-05-15"
></bryntum-scheduler>

and the content of app.component.ts with:

import { Component, ViewEncapsulation } from '@angular/core';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss'],
  encapsulation : ViewEncapsulation.None
})
export class AppComponent {
  title = 'angular-tutorial';
}

The page should now show something similar to this:

3. Loading data

The scheduler above is very empty, lets populate it with some data.

Scheduler accepts inline data by binding to events, resources etc., or it can use a CrudManager to load remote data. Depending on your setup you will want to pick one or the other.

If you, for example, have multiple widgets on your page displaying the same data, you might already have it available on the client - binding it as inline data can then be cheaper than remotely loading it also for Scheduler. But for most cases loading it remotely will be the best fit.

To load data remotely, configure crudManager with a URL to load from. Modify the previous snippet of app.component.ts:

// Code from the previous steps omitted for brevity

export class AppComponent {
  title = 'angular-tutorial';

  crudManagerConfig = {
    loadUrl  : 'assets/data.json',
    autoLoad : true
  }
}

And modify app.component.html to show the following:

<bryntum-scheduler
  [width]="800"
  [height]="600"
  startDate="2023-04-16"
  endDate="2023-05-15"
  [crudManager]="crudManagerConfig"
></bryntum-scheduler>

The response is expected in a specific format, see this guide. The data used for this tutorial is available here: data.json. An excerpt from that file:

{
  "success" : true,
  "events" : {
    "rows" : [
      {
        "id"         : 1,
        "resourceId" : 1,
        "startDate"  : "2023-04-17",
        "duration"   : 7,
        "name"       : "Project Kickoff"
      },
      {
        "..." : "..."
      }
    ]
  }
}

Note that although not shown above, the response also contains a resources section. This is used as the row source for the Scheduler. The events section is used as the event source. Also note that while events are defined with a startDate and a duration, you can also instead supply a startDate and an endDate.

To match the url used in the snippet above, please copy the data.json file to src/assets folder. With the correct load url now in place, you should be seeing the following:

4. Saving changes

As for loading data, you have multiple options for saving changes. You can use the CrudManager to sync changes automatically to the backend (by configuring it with a syncUrl and autoSync), which requires your backend to follow the CrudManager protocol. Or you can listen for changes and handle them your preferred way manually, trading ease of use on the client for flexibility on the server.

In this step we will use the latter approach. We will listen for changes, but since we have no backend in place we will just log the changes to the console. Modify the previous snippet of app.component.ts:

// Code from the previous steps omitted for brevity
import { CrudManager } from '@bryntum/scheduler';

// Code from the previous steps omitted for brevity
export class AppComponent {
  title = 'angular-tutorial';

  changesHandler = ({ source } : { source : CrudManager }) => {
    const { changes } = source;

    // In a real app you would send the changes to the server here.
    console.log(changes);

    // Then you would call `source.acceptChanges()` to clear local changes
    source.acceptChanges();
  }

  crudManagerConfig = {
    loadUrl   : 'assets/data.json',
    autoLoad  : true,
    listeners : {
      hasChanges: this.changesHandler
    }
  };

}

Try it out here (be sure to open the console to see the output):

5. Adding columns

A Scheduler by default consists of a left-hand side grid part with fixed width and a schedule part occupying the rest of the width. The grid part shows information about the resources. You can add an arbitrary number of columns to it (see the Scheduler columns guide for more info). In this step we add two columns (app.component.html):

  <!-- Code from previous steps omitted for brevity -->
<bryntum-scheduler
  [columns]="columnsConfig"
></bryntum-scheduler>

and app.component.ts:

export class AppComponent {

  // Code from previous steps omitted for brevity
  columnsConfig = [
    {
        field : 'name',
        text  : 'Name'
    },
    {
        field : 'role',
        text  : 'Role'
    }
  ];
}

The app should now look something like this:

6. Enabling features

Scheduler ships with a set of features that can be enabled/disabled and configured to affect the functionality of the component (see the Scheduler features guide). We are going to enable the Stripe feature (which gives every even row a gray background).

Alter your app.component.html, add:

<!-- Code from the previous steps omitted for brevity -->
<bryntum-scheduler
  [stripeFeature]="true"
></bryntum-scheduler>

That change yields the following app:

7. Reacting to events

Scheduler, its features and data stores fire a number of events that you can listen to, for example Scheduler fires eventClick when clicking an event, the resourceStore fires add when a new resources is added, etc. See the API docs for each class for all events (Scheduler's events are for example listed here).

To catch an event, you can add method handlers to the component using standard Angular syntax ((onEventClick) etc.), or specify declarative listeners in the Bryntum config object, or add them programmatically using the on method. In this step we will add a handler for eventClick, and a programmatic listener for the beforeEventEdit event (see the Saving changes section above for an example of using a listeners object).

First an Angular style handler for the eventClick event in app.component.html:

<!-- Code from the previous steps omitted for brevity -->
<bryntum-scheduler
  (onEventClick)="eventClickHandler($event)"
></bryntum-scheduler>

and the handler in app.component.ts:

// Code from the previous steps omitted for brevity
import { CrudManager, EventModel, Toast } from '@bryntum/scheduler';

export class AppComponent {
  // Code from the previous steps omitted for brevity
  eventClickHandler(event : { eventRecord? : EventModel }) : void {
    const { eventRecord } = event;
    Toast.show(`Clicked ${eventRecord!.name}`)
  }
}

And now a programmatic listener for the beforeEventEdit event (app.component.html):

<!-- Code from the previous steps omitted for brevity -->
<bryntum-scheduler
  #scheduler
></bryntum-scheduler>

and app.component.ts:

// Code from the previous steps omitted for brevity
import { BryntumSchedulerComponent } from '@bryntum/scheduler-angular';
import { CrudManager, EventModel, Scheduler, Toast } from '@bryntum/scheduler';

// Code from the previous steps omitted for brevity
export class AppComponent implements AfterViewInit {

  @ViewChild('scheduler') schedulerComponent! : BryntumSchedulerComponent;
  private scheduler! : Scheduler;

  ngAfterViewInit(): void {
    this.scheduler = this.schedulerComponent.instance;
    this.scheduler.on({
      beforeEventEdit:this.beforeEventEditHandler
    });
  };

  beforeEventEditHandler({ eventRecord } : { eventRecord : EventModel }) : void {
    Toast.show(`Editing ${eventRecord.name}`);
  };

  // Code from the previous steps omitted for brevity
}
You can use on... handlers for all events triggered on the Scheduler, but for more advanced use cases that require reaching into deeper parts of the API, you might have to use declarative / programmatic listeners.

8. Customizing the time axis

The cells in the schedule part are called "ticks". The size of these and the header above them can be customized using a view preset. Scheduler ships with a number of presets, but you can also define your own or extend existing ones. See the API docs for PresetManager for the full listing.

For this tutorial, we are going to extend the existing weekAndDayLetter preset to modify the top header to show the week number instead of the first date of the week. Add the following to your app.component.html:

<!-- Code from the previous steps omitted for brevity -->
<bryntum-scheduler
  [viewPreset]="viewPresetConfig"
></bryntum-scheduler>

and app.component.ts:

// Code from the previous steps omitted for brevity
export class AppComponent implements AfterViewInit {

  // Code from the previous steps omitted for brevity

  viewPresetConfig = {
    base : 'weekAndDayLetter',

    // Customize the header
    headers : [
       // Week 16 ... on the top level
       {
         unit       : 'week',
         dateFormat : 'Wp'
       },
       // M, T, W ... on the bottom level
       {
         unit       : 'day',
         dateFormat : 'd1'
       }
    ]
  };
}

The header should now have changed in your app:

9. Adding some style and color

For the last step of this tutorial we are going to apply some color and styling to the Scheduler. For more info on the topic, see the Styling guide.

An events color is derived from three sources: the scheduler, the resource and the event itself. As you might have noticed already, one of the events have a different color than the others. This is determined by the eventColor field in its data. We are going to set an eventColor on the Scheduler, to change all others.

An events look is determined in a similar way, by using the eventStyle field. In addition to changing the color, we are also going the change to another eventStyle for all events:

<!-- Code from the previous steps omitted for brevity -->
<bryntum-scheduler
  eventColor="indigo"
  eventStyle="traced"
 ></bryntum-scheduler>

The green events are now indigo instead, and the style has changed:

You can of course also use CSS to style the Scheduler and its events. For example, to add more border-radius for a rounded look (in app.component.scss):

.b-sch-event {
    border-radius : 20px;
}

Much rounder now:

That's it, you finished the tutorial 👍 Happy coding!

Contents

v7.3.0

Tutorial - Vue 3

Follow the steps in this tutorial to get this app up and running:

1. Create a Vue 3 app

In this first step we are going to create a basic Vue 3 app using Vite (as per this guide from vuejs.org).

  1. In an empty folder, run:
npm init vue@latest
  1. Choose 'y' for the first question asked, input vue-tutorial as the apps name, and then pick No for all following questions.

  2. Follow the instructions outputted by the scaffolding process:

cd vue-tutorial
npm install
npm run dev

You should now have an "empty" Vue 3 app up and running, time to include the Scheduler.

2. Include the Scheduler

Now we are going to add a minimal Scheduler to the app.

  1. Install the Scheduler packages (if you have not already, first set up the repo as per the quick start guide):
npm install @bryntum/scheduler @bryntum/scheduler-vue-3
Note that if you are using a trial, replace @bryntum/scheduler with @bryntum/scheduler@npm:@bryntum/scheduler-trial.
  1. Now replace the contents of App.vue with:
<script setup>
import '@bryntum/scheduler'
import { BryntumScheduler } from '@bryntum/scheduler-vue-3'
import '@bryntum/scheduler/scheduler.css'
import '@bryntum/scheduler/svalbard-light.css'
</script>

<template>
    <bryntum-scheduler
        :width="800"
        :height="600"
        start-date="2023-04-16"
        end-date="2023-05-15"
    ></bryntum-scheduler>
</template>

<style>

</style>

The page should now show something similar to this:

Note that none of the CSS or Vue files (except for App.vue) generated by the scaffolding process are needed for this tutorial, so you can safely delete them (and any imports of them).

3. Loading data

The scheduler above is very empty, lets populate it with some data.

Scheduler accepts inline data by binding to events, resources etc., or it can use a CrudManager to load remote data. Depending on your setup you will want to pick one or the other.

If you for example have multiple widgets on your page displaying the same data, you might already have it available on the client - binding it as inline data can then be cheaper than remotely loading it also for Scheduler. But for most cases loading it remotely will be the best fit.

To load data remotely, configure crudManager with a URL to load from. Modify the previous snippet, adding the following:

<script setup>
   // Code from the previous steps omitted for brevity

   // CrudManager handles data loading (and syncing, but not in this example)
   const crudManagerConfig = {
       loadUrl  : 'data/data.json',
       autoLoad : true
    };
</script>
<template>
   <!-- Code from the previous steps omitted for brevity -->
    <bryntum-scheduler
        :crud-manager="crudManagerConfig"
    ></bryntum-scheduler>
</template>

The response is expected in a specific format, see this guide. The data used for this tutorial is available here: data.json. An excerpt from that file:

{
  "success" : true,
  "events" : {
    "rows" : [
      {
        "id"         : 1,
        "resourceId" : 1,
        "startDate"  : "2023-04-17",
        "duration"   : 7,
        "name"       : "Project Kickoff"
      },
      {
        "..." : "..."
      }
    ]
  }
}

Note that although not shown above, the response also contains a resources section. This is used as the row source for the Scheduler. The events section is used as the event source. Also note that while events are defined with a startDate and a duration, you can also instead supply a startDate and an endDate.

To match the url used in the snippet above, please copy the data.json file to public/data/data.json. With the correct load url now in place, you should be seeing the following:

4. Saving changes

As for loading data, you have multiple options for saving changes. You can use the CrudManager to sync changes automatically to the backend (by configuring it with a syncUrl and autoSync), which requires your backend to follow the CrudManager protocol. Or you can listen for changes and handle them your preferred way manually, trading ease of use on the client for flexibility on the server.

In this step we will use the latter approach. We will listen for changes, but since we have no backend in place we will just log the changes to the console. Modify the previous snippet, adding the following:

<script setup>
    // Code from the previous steps omitted for brevity

    // CrudManager handles data loading (and syncing, but not in this example)
    const crudManagerConfig = {
        loadUrl   : 'data/data.json',
        autoLoad  : true,
        listeners : {
            // Bryntum API listener for the `hasChanges` event, triggered when any store
            // handled by the crud manager has changes
            hasChanges() {
               console.log(this.changes);

               // In a real app you would send the changes to the server here.
               // Then you would call `this.acceptChanges()` to
               // clear local changes
            }
        }
    };
</script>
<template>
    <!-- Code from the previous steps omitted for brevity -->
    <bryntum-scheduler
        :crud-manager="crudManagerConfig"
    ></bryntum-scheduler>
</template>

Try it out here (be sure to open the console to see the output):

5. Adding columns

A Scheduler by default consists of a left-hand side grid part with fixed width and a schedule part occupying the rest of the width. The grid part shows information about the resources. You can add an arbitrary number of columns to it (see the Scheduler columns guide for more info). In this step we add two columns:

<script setup>
    // Code from the previous steps omitted for brevity

    // Columns in the grid part
    const columnsConfig = [
        {
            field : 'name',
            text  : 'Name'
        },
        {
            field : 'role',
            text  : 'Role'
        }
   ];
</script>
<template>
   <!-- Code from the previous steps omitted for brevity -->
   <bryntum-scheduler
      :columns="columnsConfig"
      ></bryntum-scheduler>
</template>

The app should now look something like this:

6. Enabling features

Scheduler ships with a set of features that can be enabled/disabled and configured to affect the functionality of the component (see the Scheduler features guide). We are going to enable the Stripe feature (which gives every even row a gray background).

Alter your Scheduler config, add:

<template>
    <!-- Code from the previous steps omitted for brevity -->
    <bryntum-scheduler
        :stripe-feature="true"
        ></bryntum-scheduler>
</template>

That change yields the following app:

7. Reacting to events

Scheduler, its features and data stores fire a number of events that you can listen to, for example Scheduler fires eventClick when clicking an event, the resourceStore fires add when a new resources is added, etc. See the API docs for each class for all events (Scheduler's events are for example listed here).

To catch an event, you can add method handlers to the component using standard Vue 3 syntax (@event-click etc.), or specify declarative listeners in the Bryntum config object, or add them programmatically using the on method. In this step we will add a handler for @event-click, and a programmatic listener for the beforeEventEdit event (see the Saving changes section above for an example of using a listeners object).

First a Vue style handler for the eventClick event:

<script setup>
    // Code from the previous steps omitted for brevity

    // Handler for @event-click
    function onEventClick({ eventRecord }) {
        Toast.show(`Clicked ${eventRecord.name}`);
    }
</script>

<template>
    <!-- Code from the previous steps omitted for brevity -->
    <bryntum-scheduler
        @event-click="onEventClick"
    ></bryntum-scheduler>
</template>

And now a programmatic listener for the beforeEventEdit event:

<script setup>
    import { BryntumScheduler } from '@bryntum/scheduler-vue-3'
    import '@bryntum/scheduler/scheduler.material.css'
    // Import Toast to show a message in our event handlers
    import { Toast } from '@bryntum/scheduler'
    // Import onMounted & ref to be able to access the Scheduler instance
    // to set up a programmatic listener
    import { onMounted, ref } from 'vue'

    // Code from the previous steps omitted for brevity

    // Scheduler ref, to be able to reach it in the hook below
    const scheduler = ref(null);

    onMounted(() => {
        // Programmatic listener
        scheduler.value.instance.value.on({
            beforeEventEdit({ eventRecord })  {
                Toast.show(`Editing ${eventRecord.name}`);
            }
        })
    });
</script>

<template>
    <!-- Code from the previous steps omitted for brevity -->
    <bryntum-scheduler
        ref="scheduler"
    ></bryntum-scheduler>
</template>
You can use @ handlers for all events triggered on the Scheduler, but for more advance use cases that require reaching into deeper parts of the API, you might have to use declarative / programmatic listeners.

8. Customizing the time axis

The cells in the schedule part are called "ticks". The size of these and the header above them can be customized using a view preset. Scheduler ships with a number of presets, but you can also define your own or extend existing ones. See the API docs for PresetManager for the full listing.

For this tutorial, we are going to extend the existing weekAndDayLetter preset to modify the top header to show the week number instead of the first date of the week. Add the following to your app:

<script setup>
    // Code from the previous steps omitted for brevity

    // The view preset controls the time axis and its header
    const viewPresetConfig = {
       base : 'weekAndDayLetter',

       // Customize the header
       headers : [
          // Week 16 ... on the top level
          {
            unit       : 'week',
            dateFormat : 'Wp'
          },
          // M, T, W ... on the bottom level
          {
            unit       : 'day',
            dateFormat : 'd1'
          }
       ]
    };
</script>
<template>
    <!-- Code from the previous steps omitted for brevity -->
    <bryntum-scheduler
        :view-preset="viewPresetConfig"
   ></bryntum-scheduler>
</template>

The header should now have changed in your app:

7. Adding some style and color

For the last step of this tutorial we are going to apply some color and styling to the Scheduler. For more info on the topic, see the Styling guide.

An events color is derived from three sources: the scheduler, the resource and the event itself. As you might have noticed already, one of the events have a different color than the others. This is determined by the eventColor field in its data. We are going to set an eventColor on the Scheduler, to change all others.

An events look is determined in a similar way, by using the eventStyle field. In addition to changing the color, we are also going the change to another eventStyle for all events:

<template>
   <!-- Code from the previous steps omitted for brevity -->
   <bryntum-scheduler
        event-style="border"
        event-color="indigo"
   ></bryntum-scheduler>
</template>

The green events are now indigo instead, and the style has changed:

You can of course also use CSS to style the Scheduler and its events. For example, to add more border-radius for a rounded look:

<style>
   .b-sch-event {
       border-radius : 20px;
   }
</style>
Note that there is no scoped attribute on the style tag. Adding it would make Vite rewrite the rule, and it would no longer apply correctly.

Much rounder now:

That's it, you finished the tutorial 👍 Happy coding!

Contents

v7.3.0

Tutorial - React

Follow the steps in this tutorial to get this app up and running:

1. Create a React app

In this first step we are going to create a basic React app using Vite (as per this guide from vitejs.org).

In a folder, run:

npm create vite@latest react-tutorial -- --template react

Choose 'y' for the first question if asked.

When using Vite to run a Bryntum application in development mode, in order to fix loading bundles multiple times, it is recommended to include Bryntum packages in the optimizeDeps in vite.config.js. Please follow this guide for more configuration information.

Run application development server:

cd react-tutorial
npm install
npm run dev

You should have a React app up and running, time to include the Scheduler.

2. Include the Scheduler

Now we are going to add a minimal Scheduler to the app.

Install the Scheduler packages:

Trial version:

cd my-app
npm install @bryntum/scheduler@npm:@bryntum/scheduler-trial @bryntum/scheduler-react

Licensed version:

cd my-app
npm install @bryntum/scheduler @bryntum/scheduler-react

Now replace the contents of App.jsx with

import { BryntumScheduler } from '@bryntum/scheduler-react';
import './App.css';

function App() {
    return (
        <>
            <BryntumScheduler
                width={800}
                height={600}
                startDate="2023-04-16"
                endDate="2023-05-15"
            />
        </>
    );
}

export default App;

Replace content of App.css with

/* Structural CSS */
@import '@bryntum/scheduler/scheduler.css';
/* Bryntum theme of your choice */
@import '@bryntum/scheduler/svalbard-light.css';

body {
    font-family : sans-serif;
    font-size   : 14px;
    padding     : 0;
    margin      : 0;
}

The page should now show something similar to this:

None of the CSS or React files (except for App.jsx and App.css) generated by the scaffolding process are needed for this tutorial, so you can safely delete them (and any imports of them).

3. Loading data

The scheduler above is very empty, lets populate it with some data.

Scheduler accepts inline data by binding to events, resources etc., or it can use a CrudManager to load remote data. Depending on your setup you will want to pick one or the other.

If you, for example, have multiple widgets on your page displaying the same data, you might already have it available on the client - binding it as inline data can then be cheaper than remotely loading it also for Scheduler. But for most cases loading it remotely will be the best fit.

To load data remotely, configure crudManager with a URL to load from. Modify the previous snippet so that it shows the following:

import { useState } from 'react';
import { BryntumScheduler } from '@bryntum/scheduler-react';
import './App.css';

function App() {
    const [crudManagerConfig] = useState({
        loadUrl  : 'data/data.json',
        autoLoad : true
    });

    return (
        <>
            <BryntumScheduler
                width={800}
                height={600}
                startDate="2023-04-16"
                endDate="2023-05-15"
                crudManager={crudManagerConfig}
            />
        </>
    );
}

export default App;
We use React state to keep the same crudManagerConfig object between re-renders.

The response is expected in a specific format, see this guide. The data used for this tutorial is available here: data.json. An excerpt from that file:

{
  "success" : true,
  "events" : {
    "rows" : [
      {
        "id"         : 1,
        "resourceId" : 1,
        "startDate"  : "2023-04-17",
        "duration"   : 7,
        "name"       : "Project Kickoff"
      },
      {
        "..." : "..."
      }
    ]
  }
}

Note that although not shown above, the response also contains a resources section. This is used as the row source for the Scheduler. The events section is used as the event source. Also note that while events are defined with a startDate and a duration, you can also instead supply a startDate and an endDate.

To match the url used in the snippet above, please copy the data.json file to public/data/data.json. With the correct load url now in place, you should be seeing the following:

4. Saving changes

As for loading data, you have multiple options for saving changes. You can use the CrudManager to sync changes automatically to the backend (by configuring it with a syncUrl and autoSync), which requires your backend to follow the CrudManager protocol. Or you can listen for changes and handle them your preferred way manually, trading ease of use on the client for flexibility on the server.

In this step we will use the latter approach. We will listen for changes, but since we have no backend in place we will just log the changes to the console. Modify the previous snippet, so that it shows:

import { BryntumScheduler } from '@bryntum/scheduler-react';
import { useCallback, useState } from 'react';
import './App.css';

function App() {
    const [crudManagerConfig] = useState({
        loadUrl  : 'data/data.json',
        autoLoad : true,
        listeners : {
            // Bryntum API listener for the `hasChanges` event, triggered when any store
            // handled by the crud manager has changes
            hasChanges: bryntumEvent => handleChanges(bryntumEvent)
        }
    });

    const handleChanges = useCallback(({ source }) => {
        const { changes } = source;

        // In a real app you would send the changes to the server here.
        console.log(changes);

        // Then you would call `source.acceptChanges()` to clear local changes
        source.acceptChanges();
    }, []);

    return (
        <>
            <BryntumScheduler
                width={800}
                height={600}
                startDate="2023-04-16"
                endDate="2023-05-15"
                crudManager={crudManagerConfig}
            />
        </>
    );
}

export default App;

Try it out here (be sure to open the console to see the output):

5. Adding columns

A Scheduler by default consists of a left-hand side grid part with fixed width and a schedule part occupying the rest of the width. The grid part shows information about the resources. You can add an arbitrary number of columns to it (see the Scheduler columns guide for more info). In this step we add two columns:

function App() {

    // Code from the previous steps omitted for brevity

    // Columns in the grid part
    const [columnsConfig] = useState([
        {
            field : 'name',
            text  : 'Name'
        },
        {
            field : 'role',
            text  : 'Role'
        }
    ])

    return (
        <>
            <BryntumScheduler
                {/* Code from the previous steps omitted for brevity */}
                columns={columnsConfig}
            />
        </>
    )
}
We use React state to keep the same columnsConfig array between re-renders.

The app should now look something like this:

6. Enabling features

Scheduler ships with a set of features that can be enabled/disabled and configured to affect the functionality of the component (see the Scheduler features guide). We are going to enable the Stripe feature (which gives every even row a gray background).

Alter your Scheduler config, add:

function App() {

    // Code from the previous steps omitted for brevity

    return (
        <>
            <BryntumScheduler
                {/* Code from the previous steps omitted for brevity */}
                stripeFeature={true}
            />
        </>
    )
}

That change yields the following app:

7. Reacting to events

Scheduler, its features and data stores fire a number of events that you can listen to, for example Scheduler fires eventClick when clicking an event, the resourceStore fires add when a new resources is added, etc. See the API docs for each class for all events (Scheduler's events are for example listed here).

To catch an event, you can add method handlers to the component using standard React syntax (onEventClick etc.), or specify declarative listeners in the Bryntum config object, or add them programmatically using the on method. In this step we will add a handler for eventClick, and a programmatic listener for the beforeEventEdit event (see the Saving changes section above for an example of using a listeners object).

First a React style handler for the eventClick event:

import { Toast } from '@bryntum/scheduler';
// Code from the previous steps omitted for brevity

function App() {
    // Code from the previous steps omitted for brevity

    const handleEventClick = useCallback(({eventRecord}) => {
        Toast.show(`Clicked ${eventRecord.name}`)
    }, []);

    return (
        <>
            <BryntumScheduler
                {/* Code from the previous steps omitted for brevity */}
                onEventClick={handleEventClick}
            />
        </>
    );
}

And now a programmatic listener for the beforeEventEdit event:

import { useCallback, useState, useRef, useEffect } from 'react';

// Code from the previous steps omitted for brevity

function App() {
    const schedulerRef = useRef();

    // Code from the previous steps omitted for brevity

    const handleBeforeEventEdit = useCallback(({eventRecord}) =>{
        Toast.show(`Editing ${eventRecord.name}`);
    }, [])

    useEffect(() => {
        schedulerRef.current?.instance.on('beforeEventEdit', handleBeforeEventEdit);
    }, [schedulerRef, handleBeforeEventEdit])

    return (
        <>
            <BryntumScheduler
                ref={schedulerRef}
                {/* Code from the previous steps omitted for brevity */}
            />
        </>
    );
}
You can use on... handlers for all events triggered on the Scheduler, but for more advanced use cases that require reaching into deeper parts of the API, you might have to use declarative / programmatic listeners.

8. Customizing the time axis

The cells in the schedule part are called "ticks". The size of these and the header above them can be customized using a view preset. Scheduler ships with a number of presets, but you can also define your own or extend existing ones. See the API docs for PresetManager for the full listing.

For this tutorial, we are going to extend the existing weekAndDayLetter preset to modify the top header to show the week number instead of the first date of the week. Add the following to your app:

// Code from the previous steps omitted for brevity
function App() {

    // Code from the previous steps omitted for brevity
    const [viewPresetConfig] = useState({
        base : 'weekAndDayLetter',

        // Customize the header
        headers : [
           // Week 16 ... on the top level
           {
             unit       : 'week',
             dateFormat : 'Wp'
           },
           // M, T, W ... on the bottom level
           {
             unit       : 'day',
             dateFormat : 'd1'
           }
        ]
    });

    return (
        <>
            <BryntumScheduler
                {/* Code from the previous steps omitted for brevity */}
                viewPreset={viewPresetConfig}
            />
        </>
    );
}
We use React state to keep the same viewPresetConfig object between re-renders.

The header should now have changed in your app:

9. Adding some style and color

For the last step of this tutorial we are going to apply some color and styling to the Scheduler. For more info on the topic, see the Styling guide.

An events color is derived from three sources: the scheduler, the resource and the event itself. As you might have noticed already, one of the events have a different color than the others. This is determined by the eventColor field in its data. We are going to set an eventColor on the Scheduler, to change all others.

An events look is determined in a similar way, by using the eventStyle field. In addition to changing the color, we are also going the change to another eventStyle for all events:

    return (
        <>
            <BryntumScheduler
                {/* Code from the previous steps omitted for brevity */}
                eventColor="indigo"
                eventStyle="border"
            />
        </>
    );

The green events are now indigo instead, and the style has changed:

You can of course also use CSS to style the Scheduler and its events. For example, to add more border-radius for a rounded look (in App.css):

.b-sch-event {
    border-radius : 20px;
}

Much rounder now:

That's it, you finished the tutorial 👍 Happy coding!

Contents